#import "AccelLayer.h"

// layer children tags
enum {
    tagGunSpriteManager = 1,
};

// gun atlas sprite manager tags
enum {
    tagGunSprite,
    tagRotateBy,
};


@implementation AccelLayer

- (id) init {
    if(self = [super init]) {
        isTouchEnabled = YES;
        isAccelerometerEnabled = YES;
        captureNextAccel = YES;
        rotater = [[Rotater alloc] init];
        [self initGun];
    }
    return self;
}

- (void) dealloc {
    [rotater release];
    [super dealloc];
}

- (void) initGun {
    AtlasSpriteManager *gunMgr = [AtlasSpriteManager
            spriteManagerWithFile:@"grossini_dance_atlas.png" capacity:1];
    [self addChild:gunMgr z:0 tag:tagGunSpriteManager];
    CGSize winSize = [[Director sharedDirector] winSize];
    // [gunMgr setPosition: ccp(winSize.width / 2, winSize.height / 2)];
    int spriteWidth = 85;
    int spriteHeight = 121;
    AtlasSprite *gunSprite = [AtlasSprite 
            spriteWithRect:CGRectMake(0, spriteHeight, spriteWidth, spriteHeight)
            spriteManager:gunMgr];
    gunSprite.position = ccp(winSize.width / 2, winSize.height / 2);
    id tintred = [TintBy actionWithDuration:2 red:255 green:-255 blue:-255];
    id tintred_back = [tintred reverse];
    id red = [RepeatForever actionWithAction:
            [Sequence actions:tintred, tintred_back, nil]];
    [gunSprite runAction:red];
    [gunMgr addChild:gunSprite z:0 tag:tagGunSprite];
}

- (BOOL)ccTouchesEnded:(NSSet *)touches withEvent:(UIEvent *)event
{
    captureNextAccel = YES;
    return YES;
}

- (float) correctAngle:(float) angle {
    if (fabs(angle) > 180.0) angle -= copysign(360.0, angle);
    return angle;
}

- (void) accelerometer:(UIAccelerometer*) meter
         didAccelerate:(UIAcceleration*) accel {
    AtlasSpriteManager *gunMgr = (AtlasSpriteManager*)
            [self getChildByTag:tagGunSpriteManager];
    float rotation0 = [self correctAngle:gunMgr.rotation];
    float rotation1 = [rotater rotationForX:accel.x y:accel.y z:accel.z
                     landscape:[[Director sharedDirector] landscape]
                     capture:captureNextAccel];
    float angle = [self correctAngle:rotation1 - rotation0];
    if (captureNextAccel) captureNextAccel = NO;
    [gunMgr stopActionByTag:tagRotateBy];
    Action *rotateBy = [RotateBy actionWithDuration:fabs(angle)/360.0 
                                 angle:angle];
    [rotateBy setTag:tagRotateBy];
    [gunMgr runAction:rotateBy];
}

@end
