#import "DebugScene.h"
#import "BackgroundLayer.h"

@implementation DebugScene
- (id) init {
    if(self = [super init]) {
        [self addChild:[DebugLayer node]];
    }
    return self;
}
@end

@implementation DebugLayer
- (id) init {
    if(self = [super init]) {
        isTouchEnabled = YES;
        isAccelerometerEnabled = YES;
        captureNextAccel = YES;
        label0 = [Label labelWithString:@""
                fontName:@"Helvetica" fontSize:20];
        label1 = [Label labelWithString:@""
                fontName:@"Helvetica" fontSize:20];
        label2 = [Label labelWithString:@""
                fontName:@"Helvetica" fontSize:20];
        CGSize s = [[Director sharedDirector] winSize];
        label0.position = ccp(s.width / 2, s.height - 30);
        label1.position = ccp(s.width / 2, s.height - 60);
        label2.position = ccp(s.width / 2, s.height - 90);
        [self addChild: label0];
        [self addChild: label1];
        [self addChild: label2];
        rotater = [[Rotater alloc] init];
    }
    return self;
}

- (void) dealloc {
    [rotater release];
    [super dealloc];
}

- (void) accelerometer: (UIAccelerometer*) meter
         didAccelerate: (UIAcceleration*) accel {
    
    float rot = [rotater rotationForX:accel.x y:accel.y z:accel.z
                     landscape:[[Director sharedDirector] landscape]
                     capture:captureNextAccel];
                   
    if (captureNextAccel) {
        captureNextAccel = NO;
    }
    
    [label0 setString:[NSString stringWithFormat: 
            @"accel x, y, z = %.2f, %.2f, %.2f | x, y = %.2f, %.2f",
            accel.x, accel.y, accel.z, rotater.x, rotater.y]];
            
    [label1 setString:[NSString stringWithFormat: 
            @"base x, y, z = %.2f, %.2f, %.2f | peak x, y = %.2f, %.2f", 
            rotater.baseX, rotater.baseY, rotater.baseZ, rotater.peakX, rotater.peakY]];
    
    [label2 setString:[NSString stringWithFormat: 
            @"diff x, y = %.2f, %.2f | rotation = %.2f",
            rotater.diffX, rotater.diffY, rot]];
}

- (BOOL)ccTouchesEnded:(NSSet *)touches withEvent:(UIEvent *)event
{
    captureNextAccel = YES;
    return YES;
}

@end
