#import "MenuScene.h"
#import "GameScene.h"
#import "DebugScene.h"

@implementation MenuScene

- (id) init {
    if(self = [super init]) {
        [MenuItemFont setFontSize:20];
        [MenuItemFont setFontName:@"Helvetica"];
        MenuItem *game = [MenuItemFont 
                itemFromString:@"Start Game" 
                target:self selector:@selector(startGame:)];
        MenuItem *debug = [MenuItemFont 
                itemFromString:@"Start Debug"
                target:self selector:@selector(startDebug:)];
        Menu *menu = [Menu menuWithItems: game, debug, nil];
        [menu alignItemsVertically];
        [self addChild: menu];
    }
    return self;
}

- (void) startGame: (id) sender {
    [[Director sharedDirector] replaceScene: [GameScene node]];
}

- (void) startDebug: (id) sender {
    [[Director sharedDirector] replaceScene: [DebugScene node]];
}

@end
