#import "Rotater.h"

@implementation Rotater

@synthesize baseX, baseY, baseZ;
@synthesize peakX, peakY;
@synthesize x, y;
@synthesize diffX, diffY;

- (id) init {
    if((self = [super init])) {
        self.baseX = self.baseY = 0;
        self.baseZ = -1;
        self.peakX = self.peakY = 0;
        self.x = self.y = 0;
        self.diffX = self.diffY = 0;
    }
    return self;
}

- (float) rotationForX:(float)accelX y:(float)accelY z:(float)accelZ
          landscape:(BOOL)landscape capture:(BOOL)capture {
    
    if (landscape) {
        x = accelY;
        y = accelX;
    } else {
        x = -accelX;
        y = accelY;
    }
    
    float accelZSign = copysign(1.0, accelZ);
    x *= accelZSign;
    y *= accelZSign;
    
    if (capture) {
        baseX = x;
        baseY = y;
        baseZ = accelZ;
        peakX = x;
        peakY = y;
    } else {
        if (accelZSign == copysign(1.0, baseZ)) {
            peakX = x;
            peakY = y;
        } else {
            if (fabs(x) > fabs(peakX)) {
                peakX = x;
            }
            if (fabs(y) > fabs(peakY)) {
                peakY = y;
            }
        }
    }
                
    diffX = 2 * peakX - x - baseX;
    diffY = 2 * peakY - y - baseY;
    return CC_RADIANS_TO_DEGREES(atan2(diffY, diffX));
}

@end
