#import "GTMSenTestCase.h"
#import "Rotater.h"

@interface Triple : NSObject {float x, y, z;}
@property float x, y, z;
@end
@implementation Triple
@synthesize x, y, z;
+(id) x:(float)x y:(float)y z:(float)z {
    Triple* t = [[[self alloc] init] autorelease];
    t.x = x; t.y = y; t.z = z;
    return t;
}
@end

@interface RotaterTest : GTMTestCase {
    Rotater *rotater;
}
@end
@implementation RotaterTest

- (void) setUp {
    rotater = [[Rotater alloc] init];
}

- (void) tearDown {
    [rotater release];
}

- (void) makeAssertions:(Triple*)data expected:(float)expected {
    rotater.baseZ = data.z;
    float rotation = [rotater rotationForX:data.x y:data.y z:data.z 
                              landscape:YES capture:NO];
    STAssertEquals(expected, rotation, @"wrong rotation %.2f", rotation);
}

- (void) test0 {
    [self makeAssertions:[Triple x:0 y:-1 z:-1] expected:0];
}

- (void) test90 {
    [self makeAssertions:[Triple x:-1 y:0 z:-1] expected:90];
}

- (void) testNeg90 {
    [self makeAssertions:[Triple x:1 y:0 z:-1] expected:-90];
}

- (void) test180 {
    [self makeAssertions:[Triple x:0 y:1 z:-1] expected:180];
}

- (void) testDown0 {
    
    [self makeAssertions:[Triple x:0 y:1 z:1] expected:0];
}

- (void) testDown90 {
    [self makeAssertions:[Triple x:1 y:0 z:1] expected:90];
}

- (void) testDownNeg90 {
    [self makeAssertions:[Triple x:-1 y:0 z:1] expected:-90];
}

- (void) testDown180 {
    [self makeAssertions:[Triple x:0 y:-1 z:1] expected:180];
}

- (void) testMultiple {
    [self makeAssertions:[Triple x:0 y:-1 z:-1] expected:0];
    [self makeAssertions:[Triple x:0 y:-1 z:-1] expected:0];
    [self makeAssertions:[Triple x:0 y:1 z:-1] expected:180];
    [self makeAssertions:[Triple x:-1 y:0 z:-1] expected:90];
    [self makeAssertions:[Triple x:1 y:0 z:-1] expected:-90];
}

@end
